SystemOrganization addCategory: #ConfigurationOfStamp!

Object subclass: #ConfigurationOfStamp
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfStamp'!

!ConfigurationOfStamp commentStamp: '<historical>' prior: 0!
Stamp is an implementation of STOMP 1.2, a protocol to access message oriented middleware like RabbitMQ.


ConfigurationOfStamp load.

ConfigurationOfStamp loadBleedingEdge.


Written by Sven Van Caekenberghe - http://stfx.eu
!

!ConfigurationOfStamp class methodsFor: 'development support' stamp: 'SvenVanCaekenberghe 8/13/2013 14:32'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfStamp class methodsFor: 'private' stamp: 'SvenVanCaekenberghe 8/13/2013 14:32'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfStamp class methodsFor: 'private' stamp: 'SvenVanCaekenberghe 8/13/2013 14:32'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfStamp class methodsFor: 'private' stamp: 'SvenVanCaekenberghe 8/13/2013 14:32'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfStamp class methodsFor: 'metacello tool support' stamp: 'SvenVanCaekenberghe 8/13/2013 14:32'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfStamp class methodsFor: 'loading' stamp: 'SvenVanCaekenberghe 8/13/2013 14:32'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfStamp class methodsFor: 'loading' stamp: 'SvenVanCaekenberghe 8/13/2013 14:32'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfStamp class methodsFor: 'loading' stamp: 'SvenVanCaekenberghe 8/13/2013 14:32'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfStamp class methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 8/13/2013 14:32'!
project

	^self new project! !

!ConfigurationOfStamp class methodsFor: 'development support' stamp: 'SvenVanCaekenberghe 8/13/2013 14:32'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfStamp methodsFor: 'baselines' stamp: 'SvenVanCaekenberghe 8/13/2013 14:37'!
baseline1: spec
	<version: '1-baseline'>
	spec for: #common do: [
		spec 
			blessing: #baseline;
			repository: 'http://smalltalkhub.com/mc/SvenVanCaekenberghe/Stamp/main/';
			package: 'Stamp' ]
! !

!ConfigurationOfStamp methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 8/13/2013 14:40'!
customProjectAttributes
	^ #()! !

!ConfigurationOfStamp methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 8/13/2013 14:32'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfStamp methodsFor: 'tags' stamp: 'SvenVanCaekenberghe 12/19/2014 13:20'!
stable: spec
	<symbolicVersion: #'stable'>
	spec for: #common version: '2'! !

!ConfigurationOfStamp methodsFor: 'versions' stamp: 'SvenVanCaekenberghe 8/13/2013 14:38'!
version1: spec
	<version: '1' imports: #('1-baseline')>
	spec for: #common do: [
		spec
			blessing: #release;
			package: 'Stamp' with: 'Stamp-SvenVanCaekenberghe.19' ]
! !

!ConfigurationOfStamp methodsFor: 'versions' stamp: 'SvenVanCaekenberghe 12/19/2014 10:43'!
version2: spec
	<version: '2' imports: #('2-baseline')>
	spec for: #common do: [
		spec
			blessing: #release;
			package: 'Stamp' with: 'Stamp-SvenVanCaekenberghe.22' ]
! !
